#include "connexe.h"

connexe::connexe(expression _f)
{
  f = _f;
  for (set<string>::const_iterator var = f.variables.begin(); var != f.variables.end(); ++var)
    {
      gradient[*var] = f.derive(*var);
      //cout << *var << " : "  << gradient[*var].chaine << endl;
    }

  df_x_minus_s = expression("0");

  for (set<string>::const_iterator var = f.variables.begin(); var != f.variables.end(); ++var)
    {
      string variable = *var;
      // df_x_minus_s = df_x_minus_s + gradient[*var]*(*var + expression("s")) ;
      df_x_minus_s = df_x_minus_s + gradient[*var] * ( expression(variable)  - expression("s"+variable)  ) ;
    }

  //  cout << df_x_minus_s.chaine << endl;

};


interval connexe::gradient_evalue(domain x, domain partial_x)
{
  interval result(0);
  for (set<string>::const_iterator var = f.variables.begin(); var != f.variables.end(); ++var)
    {
      result = result + gradient[*var].Evalue(x)*partial_x[*var];
      // cout << result << endl;
    }
  return result;
}


bool connexe::star_shaped(domain x)
{

  interval negatif = interval(-1000000,0);
  bool resultat = false; 
  interval zero(0);
  

  bool rapid = true;
  for (set<string>::const_iterator var = f.variables.begin(); var != f.variables.end(); ++var)
    {
      rapid = zero.subset(gradient[*var].Evalue(x)) && rapid ;
    }
  if (rapid) { return false; }


  /*  bool rapid2 = true;
  domain corner1;
  for (set<string>::const_iterator var = f.variables.begin(); var != f.variables.end(); ++var)
    {
      rapid2 = (!zero.subset(gradient[*var].Evalue(x))) && rapid2 ;
      if (gradient[*var].Evalue(x).inf() > 0 ) 
	corner1[*var] = interval(x[*var].inf()) ; 
      else
	corner1[*var] = interval(x[*var].sup()) ; 
    }
  if (rapid2  && f.Evalue(corner1).subset(negatif)) { return true; }
  */

  for (int a = 0; a < pow(2,x.dimension()); a++)
    {
      domain corner0 = x.corner(a);
      // cout << "coin numéro :" << a << endl;
      //      corner0.out();
      
      expression df_x_minus_corner = df_x_minus_s;
      for (set<string>::const_iterator var = f.variables.begin(); var != f.variables.end(); ++var)
	{
	  df_x_minus_corner = df_x_minus_corner.substitute(  corner0[*var].inf() , "s"+*var); 
	}
      
      vector < expression > g;
      g.push_back(f);
      g.push_back(df_x_minus_corner);
      domain y;
      y["y0"] = interval(0);
      y["y1"] = interval(-1000000,0);
      
      Map G(g);
      //G.out();

      sivia test (G,y);

      int cardinal_of_unknown =  test.SIVIAfile(x,x.width()/1024);
      if (cardinal_of_unknown==0 && f.Evalue(corner0).subset(negatif) ) { return true; }
    }

  return false;

    /*  for (int a = 0; a < pow(2,x.dimension()); a++)
    {
      domain corner0 = x.corner(a);
      cout << "coin numéro :" << a << endl;
      corner0.out();
      vector <domain> visibility = x.visibility(a);
      bool result = true;
      for (int b = 0; b < visibility.size(); b++)
	{
	  cout << "b=" << b << endl;
	  visibility[b].out();	  
	  result = (!zero.subset(gradient_evalue(x,visibility[b]-corner0))) && result;
	}
      cout << result << endl;
      if (result) { return result; }
    }
  */


  return resultat;
};
