#include "curve.h"


void curve::dessine_latex_domain(out_latex latex, string color)
{

    ofstream dessin;
    const char* p = latex.fichier.c_str();
  
    dessin.open(p,ios::app);
    for(unsigned int i=0;i< size();i++) // On parcourt le tableau.
      {
	dessin.precision(8);
	dessin   << "\\psline[linewidth=0.005,linecolor=" << color  << "]{-}(" ;
	dessin   << fixed << (*this)[i]["x"].inf() << "," << (*this)[i]["y"].inf()  << ")(";
	dessin   << fixed << (*this)[i]["x"].sup() << "," << (*this)[i]["y"].inf()  << ")(";
	dessin   << fixed << (*this)[i]["x"].sup() << "," << (*this)[i]["y"].sup()  << ")(";
	dessin   << fixed << (*this)[i]["x"].inf() << "," << (*this)[i]["y"].sup()  << ")(";
	dessin   << fixed << (*this)[i]["x"].inf() << "," << (*this)[i]["y"].inf()  << ")" << endl;
      }
    dessin.close();
}




void curve::dessine_latex(out_latex latex, string color)
{

    ofstream dessin;
    const char* p = latex.fichier.c_str();
    dessin.open(p,ios::app);
    dessin.precision(3);
    domain fenetre;
    fenetre["x"] = interval(-2,2);
    fenetre["y"] = interval(-2,2);
    for(unsigned int i=0;i< size()-1;i++) // On parcourt le tableau.
      {
	if ((*this)[i+1].subset(fenetre))
		    {	
		      dessin   << "\\psline[linewidth=0.005,linecolor=" << color  << "]{-}(" ;
		      dessin << fixed   << (*this)[i]["x"].inf() << "," << (*this)[i]["y"].inf()  << ")(";
		      dessin << fixed  << (*this)[i+1]["x"].inf() << "," << (*this)[i+1]["y"].inf()  << ")" << endl;
		    }
      }
    dessin.close();
}



void curve::out()
{
    for(unsigned int i=0;i< size();i++) // On parcourt le tableau.
      {
	(*this)[i].out();
      }
}


void curve::dessine_latex_domain2(out_latex latex, string color, string variable)
{

    ofstream dessin;

    const char* p = latex.fichier.c_str();
  
    dessin.open(p,ios::app);

    dessin   << "\\psline[linewidth=0.005,linecolor=" << "black"  << "]{->}(" ;
    dessin   << -0.2 << "," << 0  << ")(";
    dessin   <<  1.2 << "," << 0  << ")" << endl;

    dessin   << "\\psline[linewidth=0.005,linecolor=" << "black"  << "]{->}(" ;
    dessin   << 0 << "," << -0.2  << ")(";
    dessin   << 0 << "," << 1.2  << ")" << endl;

    dessin.precision(8);

    for(unsigned int i=0;i< size();i++) // On parcourt le tableau.
      {
	dessin   << "\\psline[linewidth=0.025,linecolor=" << color  << "]{-}(" ;
	dessin   << fixed << (*this)[i]["t"].inf() << "," << (*this)[i][variable].inf()  << ")(";
	dessin   << fixed << (*this)[i]["t"].inf() << "," << (*this)[i][variable].sup()  << ")" << endl;
      }

    dessin.close();
}


