#ifndef _vector_field
#define _vector_field

#include <iostream>
#include <sstream>
#include <string>
#include <set>
#include <map>



#include "curve.h"
#include "taylor.h"
#include "vecteur_nD.h"
#include "expression.h"
#include "out_latex.h"


class vector_field
{

 private:
  //          string ex;
          vector < expression > expr;
	  
 public:
        // Un champ de vecteur est caractris par les expressions qui le dfinissent :
	  curve curveb,curvec,curved,curvee;
	  domain validated;
	  map < string, expression > expr2;
	  
	  // constructor :
	  //	  vector_field( string );
	  vector_field();
	  domain f(domain x);
	  domain f2(domain x);
	  domain f0_1(domain x, double h); 
	  double max_norme_f(domain x);

	  domain integrate(domain x, double H);
	  curve integrate(domain x, double H, int nb);

	  curve monotone_integrate(domain x, double H, int nb);
	  domain identite();

	  void out();
	  vector_field d();
	  
	  // Mthode d'intgration numrique non garantie  un pas. Euler.
	  curve Phase_Curve_via_Euler(double pas , domain , double fin );
	  
	  // Etape 1 
	  bool validation(domain P, double h);

	  // Calcule les coefficients de taylor de la solution (automatic differentiation)
       	  taylor Taylor(domain x, int ordre);

	  // Renvoie un pav qui contient l'image de P par flow^h
	  domain solve_taylor(domain x, double h, domain valide);
      	  vector_field direct_sum(vector_field v);


	  domain Next_Euler(double , domain ) ;      

};

#endif

